#include <FastLED.h>
#define NUM_LEDS 7
#define DATA_PIN 12
#define CLOCK_PIN 13
CRGB leds[NUM_LEDS];

#include "MSGEQ7.h"
#define pinAnalog A0
#define pinReset 3
#define pinStrobe 2
#define MSGEQ7_INTERVAL ReadsPerSecond(50)
#define MSGEQ7_SMOOTH 200

#define lowfhigh 4
#define lowflow 5
#define midfhigh 6
#define midflow 7
#define highfhigh 8
#define highflow 9
int lowthres = 60;
int highthres = 160;

CMSGEQ7<MSGEQ7_SMOOTH, pinReset, pinStrobe, pinAnalog> MSGEQ7;

void setup() {
  Serial.begin(115200);
  FastLED.addLeds<APA102, DATA_PIN, CLOCK_PIN, BGR>(leds, NUM_LEDS);
  MSGEQ7.begin();
  for (char i = 4; i < 10; i++) {
    pinMode(i, OUTPUT);
  }
  for (char i = 4; i < 10; i++) {
    digitalWrite(i, LOW);
  }
}

void loop() {
  bool newReading = MSGEQ7.read(MSGEQ7_INTERVAL);
  if (newReading) {
    uint8_t val = MSGEQ7.get(MSGEQ7_BASS);
    val = mapNoise(val);
    Serial.print(val);
    Serial.print(" ");
    leds[5].setRGB(val, val, val);
    if (val > lowthres) {
      digitalWrite(lowflow, HIGH);
    }
    if (val > highthres) {
      digitalWrite(lowfhigh, HIGH);
    }
    if (val < highthres) {
      digitalWrite(lowfhigh, LOW);
    }
    if (val < lowthres) {
      digitalWrite(lowflow, LOW);
    }
    val = MSGEQ7.get(MSGEQ7_MID);
    val = mapNoise(val);
    Serial.print(val);
    Serial.print(" ");
    leds[4].setRGB(val, val, val);
    leds[3].setRGB(val, val, val);
    if (val > lowthres) {
      digitalWrite(midflow, HIGH);
    }
    if (val > highthres) {
      digitalWrite(midfhigh, HIGH);
    }
    if (val < highthres) {
      digitalWrite(midfhigh, LOW);
    }
    if (val < lowthres) {
      digitalWrite(midflow, LOW);
    }
    val = MSGEQ7.get(MSGEQ7_HIGH);
    val = mapNoise(val);
    Serial.print(val);
    Serial.print(" ");
    Serial.println();
    leds[2].setRGB(val, val, val);
    if (val > lowthres) {
      digitalWrite(highflow, HIGH);
    }
    if (val > highthres) {
      digitalWrite(highfhigh, HIGH);
    }
    if (val < highthres) {
      digitalWrite(highfhigh, LOW);
    }
    if (val < highthres) {
      digitalWrite(highfhigh, LOW);
    }
    if (val < lowthres) {
      digitalWrite(highflow, LOW);
    }
    FastLED.show();
  }
}
